/*******************************************************************************
 * References:
 *   - http://en.wikipedia.org/wiki/Data_Encryption_Standard
 *   - http://csrc.nist.gov/publications/fips/fips46-3/fips46-3.pdf
 *
 * Test vectors:
 *   - https://www.cosic.esat.kuleuven.be/nessie/testvectors/bc/des/Des-64-64.test-vectors
 *
 ******************************************************************************/

#include "stdint.h"

void main() {
    uint8_t block[8] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
    uint8_t key1[16] = {0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
    uint8_t key2[48] = {0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

    DES_Enc(block, key1);
    DES_Dec(block, key1);

    TDES_Enc(block, key2);
    TDES_Dec(block, key2);
}