/*******************************************************************************
 * References:
 *   - http://en.wikipedia.org/wiki/RC5
 *   - http://people.csail.mit.edu/rivest/Rivest-rc5.pdf
 *
 * Test vectors:
 *   - https://www.cosic.esat.kuleuven.be/nessie/testvectors/bc/rc5/Rc5-128-64.verified.test-vectors
 *
 ******************************************************************************/

#include "CryptoLib.h"

void main() {
   uint8_t block[8] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   uint8_t key[16]  = {0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                       0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   rc5_t state;

   RC5_Init(key, &state);

   RC5_Enc(block);
   RC5_Dec(block);
}