/*******************************************************************************
 * References:
 *   - http://en.wikipedia.org/wiki/RC6
 *   - http://people.csail.mit.edu/rivest/pubs/RRSY98.pdf
 *
 * Test vectors:
 *   - 128-bit: https://www.cosic.esat.kuleuven.be/nessie/testvectors/bc/rc6/Rc6-128-128.verified.test-vectors
 *   - 192-bit: https://www.cosic.esat.kuleuven.be/nessie/testvectors/bc/rc6/Rc6-192-128.verified.test-vectors
 *   - 256-bit: https://www.cosic.esat.kuleuven.be/nessie/testvectors/bc/rc6/Rc6-256-128.verified.test-vectors
 *
 ******************************************************************************/

#include "CryptoLib.h"

void main() {
   uint8_t block[16] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   uint8_t key[32]   = {0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   rc6_t state;

   RC6_Init(key, 256, &state);

   RC6_Enc(block);
   RC6_Dec(block);
}