#ifndef CRYPTOLIB_H_
#define CRYPTOLIB_H_

#include "stdint.h"

// RC4
typedef struct {
   uint8_t i, j;
   uint8_t s[256];
} rc4_t;

// RC5
typedef struct {
   uint32_t s[2 * (12 + 1)];
} rc5_t;

// RC6
typedef struct {
   uint32_t s[2 * 20 + 4];
} rc6_t;

// Serpent
typedef uint32_t skey_t[4];

typedef struct {
   skey_t k[33];
} serpent_t;

// MD5
typedef struct {
   uint32_t h[4];
   uint32_t length;
} md5_t;

typedef uint8_t md5_hash_t[16];

// SHA1
typedef struct {
   uint32_t h[5];
   uint32_t length;
} sha1_t;

typedef uint8_t sha1_hash_t[20];

// SHA256
typedef struct {
   uint32_t h[8];
   uint32_t length;
} sha256_t;

typedef uint8_t sha256_hash_t[32];

// HMAC-MD5
typedef struct{
   md5_t a,b;
} hmac_md5_t;

// HMAC-SHA1
typedef struct{
   sha1_t a, b;
} hmac_sha1_t;

// HMAC-SHA256
typedef struct {
   sha256_t a,b;
} hmac_sha256_t;

#endif
