/*******************************************************************************
 * References:
 *   - http://en.wikipedia.org/wiki/Serpent_%28cipher%29
 *
 * Test vectors:
 *   - 128-bit: http://www.cs.technion.ac.il/~biham/Reports/Serpent/Serpent-128-128.verified.test-vectors
 *   - 192-bit: http://www.cs.technion.ac.il/~biham/Reports/Serpent/Serpent-192-128.verified.test-vectors
 *   - 256-bit: http://www.cs.technion.ac.il/~biham/Reports/Serpent/Serpent-256-128.verified.test-vectors
 *
 ******************************************************************************/

#include "CryptoLib.h"

void main() {
   uint8_t block[16] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   uint8_t key[16]   = {0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
   serpent_t s;

   Serpent_Init(key, 128, &s);

   Serpent_Enc(block);
   Serpent_Dec(block);
}